﻿using SMTPServer.Exceptions;
using System;
using System.Collections.Generic;
using System.Text;

namespace SMTPServer
{
    public class MailQueue
    {
        private static List<QueueMail> _Mails = null;

        public static void AddToMesssageQueue(Mail mail)
        {
            lock (_Mails)
            {
                if (_Mails == null)
                {
                    _Mails = new List<QueueMail>();
                }
                _Mails.Add(new QueueMail(mail));
            }
        }

        public static QueueMail GetNextMail()
        {
            lock (_Mails)
            {
                if(_Mails.Count < 1)
                {
                    throw new NoMailsInQueueException();
                }
                
                var m = _Mails[0];

                _Mails.Remove(m);
                m._Count++;
                _Mails.Add(m);

                return m;
            }
        }

        public static void RemoveMailFromQueue(QueueMail mail)
        {
            lock (_Mails)
            {
                _Mails.Remove(mail);
            }
        }

        public class QueueMail
        {
            public DateTime _QueueEntered { get; private set; }
            public int _Count { get; set; }
            public Mail _Mail { get; private set; }

            public QueueMail (Mail mail)
            {
                _Mail = mail;
                _QueueEntered = DateTime.Now;
                _Count = 0;
            }
        }
    }
}
