﻿using System;
using System.Collections.Generic;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;

namespace SMTPServer
{
    class StartTcpConnection : Socket
    {
        private List<string> _Lines = new List<string>();
        private string _Others { get; set; }
        private Encoding _Encoding { get; set; }

        public StartTcpConnection(int port, IPAddress destination, Encoding encoding) : base (AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
        {
            this.Connect(new IPEndPoint(destination, port));
            Thread readLines = new Thread(new ThreadStart(ReadClientInput));
        }

        private void ReadClientInput()
        {
            while (true)
            {
                byte[] buffer = new byte[this.ReceiveBufferSize];
                Receive(buffer);

                var str = _Encoding.GetString(buffer);
                lock (_Others)
                {
                    _Others += str;
                }

                CheckLines();
            }
        }

        private void CheckLines()
        {
            lock (_Others)
            {
                var line = "";
                foreach (char c in _Others)
                {
                    if (c.Equals('\n'))
                    {
                        lock (_Lines)
                        {
                            _Lines.Add(line);
                            line = "";
                        }
                    }
                    else line += c;
                }
                _Others = line;
            }
        }

        public string GetLine()
        {
            lock (_Lines)
            {
                return _Lines[0];
            }
        }
    }
}
